Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeNode.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeNode.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeNode.cs	(revision 5510)
@@ -31,7 +31,7 @@
   public class SymbolicExpressionTreeNode : DeepCloneable, ISymbolicExpressionTreeNode {
     [Storable]
-    private IList<SymbolicExpressionTreeNode> subTrees;
+    private IList<ISymbolicExpressionTreeNode> subTrees;
     [Storable]
-    private Symbol symbol;
+    private ISymbol symbol;
 
     // cached values to prevent unnecessary tree iterations
@@ -39,5 +39,5 @@
     private ushort height;
 
-    public Symbol Symbol {
+    public ISymbol Symbol {
       get { return symbol; }
       protected set { symbol = value; }
@@ -45,6 +45,6 @@
 
     // parent relation is not persisted or cloned (will be set on AddSubtree or RemoveSubtree)
-    private SymbolicExpressionTreeNode parent;
-    internal SymbolicExpressionTreeNode Parent {
+    private ISymbolicExpressionTreeNode parent;
+    public ISymbolicExpressionTreeNode Parent {
       get { return parent; }
       set { parent = value; }
@@ -56,6 +56,6 @@
       : base() {
       symbol = original.symbol; // symbols are reused
-      subTrees = new List<SymbolicExpressionTreeNode>(original.SubTrees.Count);
-      foreach (var subtree in original.SubTrees) {
+      subTrees = new List<ISymbolicExpressionTreeNode>(original.subTrees.Count);
+      foreach (var subtree in original.subTrees) {
         var clonedSubTree = cloner.Clone(subtree);
         subTrees.Add(clonedSubTree);
@@ -73,7 +73,7 @@
     }
 
-    public SymbolicExpressionTreeNode(Symbol symbol)
+    public SymbolicExpressionTreeNode(ISymbol symbol)
       : base() {
-      subTrees = new List<SymbolicExpressionTreeNode>(3);
+      subTrees = new List<ISymbolicExpressionTreeNode>(3);
       this.symbol = symbol;
     }
@@ -82,5 +82,5 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      foreach (var subtree in SubTrees) {
+      foreach (var subtree in subTrees) {
         subtree.Parent = this;
       }
@@ -91,5 +91,5 @@
     }
 
-    public virtual IList<SymbolicExpressionTreeNode> SubTrees {
+    public virtual IEnumerable<ISymbolicExpressionTreeNode> SubTrees {
       get { return subTrees; }
     }
@@ -103,7 +103,7 @@
       else {
         size = 1;
-        if (SubTrees != null) {
-          for (int i = 0; i < SubTrees.Count; i++) {
-            checked { size += (ushort)SubTrees[i].GetSize(); }
+        if (subTrees != null) {
+          for (int i = 0; i < subTrees.Count; i++) {
+            checked { size += (ushort)subTrees[i].GetSize(); }
           }
         }
@@ -115,6 +115,6 @@
       if (height > 0) return height;
       else {
-        if (SubTrees != null) {
-          for (int i = 0; i < SubTrees.Count; i++) height = Math.Max(height, (ushort)SubTrees[i].GetHeight());
+        if (subTrees != null) {
+          for (int i = 0; i < subTrees.Count; i++) height = Math.Max(height, (ushort)subTrees[i].GetHeight());
         }
         height++;
@@ -126,47 +126,51 @@
     public virtual void ShakeLocalParameters(IRandom random, double shakingFactor) { }
 
-    public virtual void AddSubTree(SymbolicExpressionTreeNode tree) {
-      SubTrees.Add(tree);
+    public virtual ISymbolicExpressionTreeNode GetSubTree(int index) {
+      return subTrees[index];
+    }
+    public virtual int IndexOfSubTree(ISymbolicExpressionTreeNode tree) {
+      return subTrees.IndexOf(tree);
+    }
+    public virtual void AddSubTree(ISymbolicExpressionTreeNode tree) {
+      subTrees.Add(tree);
       tree.Parent = this;
       ResetCachedValues();
     }
-
-    public virtual void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
-      SubTrees.Insert(index, tree);
+    public virtual void InsertSubTree(int index, ISymbolicExpressionTreeNode tree) {
+      subTrees.Insert(index, tree);
       tree.Parent = this;
       ResetCachedValues();
     }
-
     public virtual void RemoveSubTree(int index) {
-      SubTrees[index].Parent = null;
-      SubTrees.RemoveAt(index);
+      subTrees[index].Parent = null;
+      subTrees.RemoveAt(index);
       ResetCachedValues();
     }
 
-    public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPrefix() {
-      List<SymbolicExpressionTreeNode> list = new List<SymbolicExpressionTreeNode>();
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPrefix() {
+      List<ISymbolicExpressionTreeNode> list = new List<ISymbolicExpressionTreeNode>();
       ForEachNodePrefix((n) => list.Add(n));
       return list;
     }
 
-    public void ForEachNodePrefix(Action<SymbolicExpressionTreeNode> a) {
+    public void ForEachNodePrefix(Action<ISymbolicExpressionTreeNode> a) {
       a(this);
       if (SubTrees != null) {
-        for (int i = 0; i < SubTrees.Count; i++) {
-          SubTrees[i].ForEachNodePrefix(a);
-        }
-      }
-    }
-
-    public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPostfix() {
-      List<SymbolicExpressionTreeNode> list = new List<SymbolicExpressionTreeNode>();
+        foreach (var subtree in SubTrees) {
+          subtree.ForEachNodePrefix(a);
+        }
+      }
+    }
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPostfix() {
+      List<ISymbolicExpressionTreeNode> list = new List<ISymbolicExpressionTreeNode>();
       ForEachNodePostfix((n) => list.Add(n));
       return list;
     }
 
-    public void ForEachNodePostfix(Action<SymbolicExpressionTreeNode> a) {
+    public void ForEachNodePostfix(Action<ISymbolicExpressionTreeNode> a) {
       if (SubTrees != null) {
-        for (int i = 0; i < SubTrees.Count; i++) {
-          SubTrees[i].ForEachNodePostfix(a);
+        foreach (var subtree in SubTrees) {
+          subtree.ForEachNodePostfix(a);
         }
       }
@@ -190,5 +194,6 @@
     private void ResetCachedValues() {
       size = 0; height = 0;
-      if (parent != null) parent.ResetCachedValues();
+      SymbolicExpressionTreeNode parentNode = parent as SymbolicExpressionTreeNode;
+      if (parentNode != null) parentNode.ResetCachedValues();
     }
   }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeSizeConstraintOperator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeSizeConstraintOperator.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeSizeConstraintOperator.cs	(revision 5510)
@@ -52,7 +52,4 @@
 
     #region Properties
-    public IRandom Random {
-      get { return RandomParameter.ActualValue; }
-    }
     public IntValue MaximumSymbolicExpressionTreeLength {
       get { return MaximumSymbolicExpressionTreeLengthParameter.ActualValue; }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeTerminalNode.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeTerminalNode.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/SymbolicExpressionTreeTerminalNode.cs	(revision 5510)
@@ -24,12 +24,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Linq;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
   [StorableClass]
   public abstract class SymbolicExpressionTreeTerminalNode : SymbolicExpressionTreeNode {
-    private static List<SymbolicExpressionTreeNode> emptyList = new List<SymbolicExpressionTreeNode>();
-    public override IList<SymbolicExpressionTreeNode> SubTrees {
+    public override IEnumerable<ISymbolicExpressionTreeNode> SubTrees {
       get {
-        return SymbolicExpressionTreeTerminalNode.emptyList;
+        return Enumerable.Empty<ISymbolicExpressionTreeNode>();
       }
     }
@@ -37,5 +37,5 @@
     [StorableConstructor]
     protected SymbolicExpressionTreeTerminalNode(bool deserializing) : base(deserializing) { }
-    // don't call storable constructor of base to prevent allocation of sub-trees list in base!
+    // don't call cloning constructor of base to prevent allocation of sub-trees list in base!
     protected SymbolicExpressionTreeTerminalNode(SymbolicExpressionTreeTerminalNode original, Cloner cloner)
       : base() {
@@ -51,8 +51,14 @@
     }
 
-    public override void AddSubTree(SymbolicExpressionTreeNode tree) {
+    public override int IndexOfSubTree(ISymbolicExpressionTreeNode tree) {
+      return -1;
+    }
+    public override ISymbolicExpressionTreeNode GetSubTree(int index) {
       throw new NotSupportedException();
     }
-    public override void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
+    public override void AddSubTree(ISymbolicExpressionTreeNode tree) {
+      throw new NotSupportedException();
+    }
+    public override void InsertSubTree(int index, ISymbolicExpressionTreeNode tree) {
       throw new NotSupportedException();
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Argument.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Argument.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Argument.cs	(revision 5510)
@@ -55,5 +55,5 @@
     }
 
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new ArgumentTreeNode(this);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Defun.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Defun.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Defun.cs	(revision 5510)
@@ -42,5 +42,5 @@
     }
 
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new DefunTreeNode(this);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/InvokeFunction.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/InvokeFunction.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/InvokeFunction.cs	(revision 5510)
@@ -60,5 +60,5 @@
     }
 
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new InvokeFunctionTreeNode(this);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/ProgramRootSymbol.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/ProgramRootSymbol.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/ProgramRootSymbol.cs	(revision 5510)
@@ -38,5 +38,5 @@
       return new ProgramRootSymbol(this, cloner);
     }
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new SymbolicExpressionTreeTopLevelNode(this);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/StartSymbol.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/StartSymbol.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/StartSymbol.cs	(revision 5510)
@@ -39,5 +39,5 @@
     }
 
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new SymbolicExpressionTreeTopLevelNode(this);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Symbol.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Symbol.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Symbols/Symbol.cs	(revision 5510)
@@ -64,5 +64,5 @@
 
 
-    public virtual SymbolicExpressionTreeNode CreateTreeNode() {
+    public virtual ISymbolicExpressionTreeNode CreateTreeNode() {
       return new SymbolicExpressionTreeNode(this);
     }
